"""The ButtonController module contains the class that 
   builds controllers for buttons of the GUI.
"""
from Tkinter import *

class Controller(object) :
    """Controller constructs a controller that remembers the
       the number of times a button is pressed.
       The controller holds the event-handling function.

       It remembers these attributes:
          mybutton - the button to which this controller 
                     is connected
          mycount - an int, how many times the button 
                     has been pressed
    """

    def __init__(self, b) :
        """init  constructs the controller

           parameters: self - the new controller object 
                              we are constructing
                       b - the button controlled by 
                              this controller
        """
        # create these two variables in the controller's 
        #   namespace:
        self.mybutton = b
        self.mycount = 0


    def handle(self) :
        """This is the event handler for the button."""
        # update  mycount  in this controller's namespace:
        self.mycount = self.mycount + 1
        # reconfigure the button controlled by this controller:
        self.mybutton.configure(text = self.mycount)
